#include <bits/stdc++.h>
using namespace std;

int n;
vector<vector<int> > g;
vector<bool> used;

pair<long long, long long> dfs2(int v){
    used[v] = true;
    if (g[v].empty()){
        //cout << "dfs2(" << v << ") = " << 1 << " " << 1 << endl;
        return pair<long long, long long>(1, 1);
    }
    if (g[v].size() == 1){
        pair<long long, long long> res = dfs2(g[v][0]);
        res.second++;
        //cout << "dfs2(" << v << ") = " << res.first << " " << res.second << endl;
        return res;
    }
    vector<pair<long long, long long>> d(g[v].size());
    for (int i = 0; i < g[v].size(); i++)
        if (!used[g[v][i]])
            d[i] = dfs2(g[v][i]);
    long long m1 = 0, m2 = 0, maxfig = 0;
    for (int i = 0; i < g[v].size(); i++){
        if (d[i].second < m1 && d[i].second > m2)
            m2 = d[i].second;
        if (d[i].second >= m1 && d[i].second > m2){
            m2 = m1;
            m1 = d[i].second;
        }
        if (d[i].first > maxfig)
            maxfig = d[i].first;
    }
    //cout << "dfs2(" << v << ") = " << max(maxfig, m1 + m2 + 1) << " " << m1 + 1 << endl;
    return pair<long long, long long>(max(maxfig, m1 + m2 + 1), m1 + 1);
}

int main(){
    int m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    for (int i = 1; i < n; i++){
        int a;
        cin >> a;
        g[a - 1].push_back(i);
    }
    pair<long long, long long> r = dfs2(0);
    long long res = (m - 1) * r.second * 2 + r.first;
    cout << res << endl;
}
