#include <bits/stdc++.h>
using namespace std;

int n;
vector<vector<int> > g;
vector<bool> used;
vector<int> d;

void dfs(int v, int dist){
    used[v] = true;
    d[v] = dist;
    for (int i = 0; i < g[v].size(); i++)
        if (!used[g[v][i]])
            dfs(g[v][i], dist + 1);
}

int main(){
    int m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    d.resize(n);
    for (int i = 1; i < n; i++){
        int a;
        cin >> a;
        g[a - 1].push_back(i);
    }
    dfs(0, 1);
    vector<bool> last(n);
    for (int i = 1; i < n; i++)
        if (g[i].empty())
            last[i] = true;
    long long m1 = 0;
    for (int i = 1; i < n; i++){
        if (!last[i])
            continue;
        if (d[i] > m1)
            m1 = d[i];
    }
    long long res = (m - 1) * m1 * 2;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < g[i].size(); j++)
            g[g[i][j]].push_back(i);
    int di = 0;
    for (int i = 1; i < n; i++){
        if (!last[i])
            continue;
        for (int j = 0; j < n; j++)
            used[j] = false;
        dfs(i, 1);
        for (int j = 1; j < n; j++)
            di = max(di, d[j]);
    }
    cout << res + di << endl;
}
